%Programm, welches aus den logischen Legosteinkooridinaten der hinterlegten
%Excel Tabelle die bentigten realen Kooridinaten errechnet und diese
%nacheinander anfhrt.

clear all;
close all;

%Version vom 17.1.2018

%Definiere Konstanten -> Drfen nicht gendert werden im Programmablauf !!!
%Passen die Werte?
LEGOABSTANDNOPPEN = 0.0078;   
LEGOSTEINHOEHE    = 0.0096;     

%Zur Darstellung der Steine im plot
XDISPMIN = -0.4; 
XDISPMAX = 0.4;
YDISPMIN = -0.4;
YDISPMAX = 0.4;

%Zur korrekten Funktion des Programms muss die Verbindung ber TCP/IP
%hergestellt werden

%connSuccess = initConnection();  %Zum testen ohne Verbindung auskommentiert

connSuccess = 1; %Diese Zeile rausnehmen sobald in Lan von Roboter
if(~ connSuccess == 1)
    %Wenn die Verbindung nicht hergestellt werden konnte beende das
    %Programm.
    
    return
    
end
    
%%Nimm die Positionen im Vorfeld auf (Greifer geschlossen mit Legostein an Positionen fhren)

%Die im folgenden aufgenommenen Kooridinaten dienen zu zwei Zwecken
%->Transformation Legoplattenkooridinaten zu Roboterkooridinaten, bestimme
%   den Winkel um welche die Legoplatte gedreht werden muss
%->Ermittlung der Roboterkooridinaten des (0,0,0) Punkts in
%Legokooridinaten
%   Im restlichen Programm wird angenommen, dass zur "Kalibrierung" ein platzierter
%   2x2 Stein genutzt wird, der ganz unten links auf der Legoplatte
%   platziert wird

%pUL -> Position unten links auf der Legoplatte -> aufnehmen!!!!
PUL_X = -0.2329;
PUL_Y = 0.4239;
PUL_Z = 0.0319;
PUL_RX = 1.18;
PUL_RY = 2.89;
PUL_RZ = 0.03;

%Kooridinatenvektor
KUL = [PUL_X;PUL_Y;PUL_Z];

%pUR -> Position unten rechts auf der Legoplatte -> aufnehmen!!!!
PUR_X = -0.2875;
PUR_Y = 0.3659;
PUR_Z = 0.031;
PUR_RX = 1.18;
PUR_RY = 2.88;
PUR_RZ = 0.001;

%Kooridinatenvektor
KUR = [PUR_X;PUR_Y;PUR_Z];

%pUR -> Position unten rechts auf der Legoplatte -> aufnehmen!!!!
POR_X = 0;
POR_Y = 0;
POR_Z = 0;
POR_RX = 0;
POR_RY = 0;
POR_RZ = 0;

%Kooridinatenvektor
KOR = [POR_X;POR_Y;POR_Z];

POL_X = 0;
POL_Y = 0;
POL_Z = 0;
POL_RX = 0;
POL_RY = 0;
POL_RZ = 0;

%Kooridinatenvektor
KOR = [POL_X;POL_Y;POL_Z];


%die Transformationsmatrix hat folgende Form
%(ca -sa 0 tx)
%(sa  ca 0 ty)
%(0   0  1 tz)
%(0   0  0 1 ) 

%Vergleiche Punkt in realen Legokooridinaten mit Punkt in globalen
%Legokooridinaten

%1. genutzte Bedingung T * x = xt (xt: x transformiert hier Punkt unten links)
%(ca -sa 0 tx)  (0) (tx)
%(sa  ca 0 ty) *(0)=(ty)
%(0   0  1 tz)  (0) (tz)
%(0   0  0 1 )  (1) (1 )

%2. genutzte Bedingung (l:Abstand zweier legonoppen 10 als Beispiel, am besten Lnge der Legoplatte nehmen)
%(ca -sa 0 tx)  (10*l)  (10*l*ca + tx)
%(sa  ca 0 ty) *(0)   = (10*l*sa +ty)
%(0   0  1 tz)  (0)     (tz)
%(0   0  0 1 )  (1)     (1 )

%Resultierender Punkt liegt unten rechts


%Aus 1: 

tx = PUL_X;  %Gehe vom Mittelpunkt des 2x2 Steines zum Pin unten links
ty = PUL_Y;
tz = PUL_Z;

%tx = 0;  %Nur zum Debuggen
%ty = 0;
%tz = 0;

l = LEGOABSTANDNOPPEN; %fr krzere Schreibweise

%Aus 2: ((10*l*ca + tx) == PUR_X) -> ca == (PUR_X-tx)/(10*l)

ca = (PUR_X-PUL_X)/(10*l);

%Aus 2: (10*l*sa +ty) == PUR_Y -> sa == (PUR_Y-ty)/(10*l)

sa = (PUR_Y-PUL_Y)/(10*l);

transfMatrix = [ca, -sa, 0, tx; sa, ca, 0, ty; 0, 0, 1,tz; 0, 0, 0, 1];     %Erstelle die Transformationsmatrix

%Referenzpunkt fr mit geschlossenem Greifer gefhrtem 4x2 Legostein
%(horizontal) ermittelt Nein

REF_PINUNTENLINKS_X = 0;
REF_PINUNTENLINKS_Y = 0;
REF_PINUNTENLINKS_Z = 0;


%Legostein-Structs haben folgenden Aufbau
%->steinnummer
%->typ
%->farbe
%->xKooridinateL ->L:Logisch 
%->yKooridinateL
%->zKooridinateL
%
%->laengeN %in "LegosteinNoppen"
%->breiteN 
%->laengeM %in m
%->breiteM % in m
%->xKooridinateRP ->R:Real P: Platte-Legoplatte
%->yKooridinateRP ->R:Real P: Platte-Legoplatte 
%->zKooridinateRP ->R:Real P: Platte
%->KooridinatenRG[x,y,z] -> Reale Kooridinaten als Vektor

%Die Realen Kooridinaten beschreiben den Mittelpunkt des Legosteins (!!!)
%Die logischen Kooridinaten hingegen beschreiben die Noppe in der Ecke
%unten links

%Die logischen Kooridinaten "zeigen" auf den unteren linken pin der Stelle
%an welche der Legostein gesetzt werden soll.
%Die realen Kooridinaten hingegen zeigen auf den Mittelpunkt der Stelle, an
%welche der Stein gesetzt werden soll, wohin der TCP bewegt werden soll.


excelTabelle = xlsread('Robokoords.xlsx','','','basic'); %Lies die Tabelle ein

[h, b] = size(excelTabelle);


zeileNr = 1;

%Iteriere durch die erstellte Exceltabelle um die Datenstruktur zu
%erstellen mit welcher spter gearbeitet werden soll.

legoSteinListe = []; %Erstelle einen Vektor/Liste in welche die zu setzenden Legosteine eingefgt werden sollen

while zeileNr <= h
    %Bearbeite jede Zeile einzeln
    aktZeile = excelTabelle(zeileNr,:);  %Nimm die gesamte Zeile
    naechsterStein = struct;    %Erstelle eine neue strukturierte Variable um die Informationen zu verarbeiten
    naechsterStein.steinnummer = aktZeile(1);
    naechsterStein.typ = aktZeile(2);   %Der Typ wird auch durch eine Dezimalzahl kodiert
    naechsterStein.farbe = aktZeile(3);
    naechsterStein.xKooridinateL = aktZeile(4);
    naechsterStein.yKooridinateL = aktZeile(5);
    naechsterStein.zKooridinateL = aktZeile(6);     %Steine in der Ebene sind bei einer logischen 0!!!!
    
    %Typ -> Abmessungen, ersten zwei logische Lngen in Noppen, letzte 
    [laengeN, breiteN, laengeM, breiteM] = ermittleAbmessungen(naechsterStein.typ);
    
    naechsterStein.laengeN = laengeN; % in Noppen
    naechsterStein.breiteN = breiteN;
    naechsterStein.laengeM = laengeM; % in Metern
    naechsterStein.breiteM = breiteM;
    
    legoSteinListe = [legoSteinListe, naechsterStein];  %evtl effizienter lsen?
    zeileNr = zeileNr + 1;
end


%Nachdem die Steine alle in der Liste liegen, bestimme die realen
%Kooridinaten  auf der Legoplatte und Hnge diese an die Jeweiligen Structs
%in der Liste an
%!!!In diesem Schritt werden die Realen Kooridinaten in Metern berechnet,
%der Ursprung sitzt dabei in der Noppe in der unteren linken Ecke der
%Platte.

index = 1;

while index <= h
    %Gehe wie folgt vor
    %Reale Kooridinate in Meter = Anzahl Noppen bis Kooridinate * Abstand
    %Noppen
    %Von Ausgangspunkt Noppe unten links
    
    %Die realen Kooridinaten zeigen auf den Mittelpunkt des zu setzenden
    %Steins
    
    legoSteinListe(index).xKooridinateRP = legoSteinListe(index).xKooridinateL * LEGOABSTANDNOPPEN + (legoSteinListe(index).laengeM/2) - LEGOABSTANDNOPPEN; 
    legoSteinListe(index).yKooridinateRP = legoSteinListe(index).yKooridinateL * LEGOABSTANDNOPPEN + (legoSteinListe(index).breiteM/2) - LEGOABSTANDNOPPEN;
    legoSteinListe(index).zKooridinateRP = legoSteinListe(index).zKooridinateL * LEGOSTEINHOEHE;    %Steine auf dem "boden" sind bei einer logischen z = 0
    
    % RP Kooridinate -> Real legoPlatte
    % -> Noch nicht in Roboterkooridinaten
    
    index = index + 1;
end

%Wenn die Kooridinaten in Kooridinaten der Legoplatte vorliegen, mssen
%diese noch in die Kooridinaten des Roboters umgerechnet werden.

%Stelle hier den Plot zum Debuggen ein
legomap = plot(0,0);
axis([XDISPMIN XDISPMAX YDISPMIN YDISPMAX]);
grid on;
grid minor;

%Bestimme die realen globalen kooridinaten der legosteine, mittelpunkte zum
%anfahren

index = 1;
while index <= h    
    legoSteinListe(index).kooridinatenRG = transfMatrix * [legoSteinListe(index).xKooridinateRP ; legoSteinListe(index).yKooridinateRP ;legoSteinListe(index).zKooridinateRP; 1];
    index = index + 1;
end

%Hier optional: bestimme eine Rangbeziehung zwischen den einzelnen
%anzufahrenden Kooridinaten

%Stelle als nchstes die Kooridinaten in einem Plot dar
%-> berprfe ob die Transformation korrekt durchgefhrt worden ist.

%Spter: Mache fr einzelne Ebenen momentan alles in einer Ebene
index = 1;
while index <= h
    %Bestimme Kooridinaten or ol ur ul -> 4 Ecken untransformiert
    %Bestimme 4 Ecken transformierter Stein, transformiere jede Ecke
    %einzeln
    
    %Wie oben beschrieben wird eine homogene Transfomation angenommen ->
    %z-Achse ignoriert
    
    steinNr = legoSteinListe(index).steinnummer;
    
    x_mitte = legoSteinListe(index).xKooridinateRP;
    y_mitte = legoSteinListe(index).yKooridinateRP;
    
    %Bestimme untransformierte Legoplattenkooridinaten
    xol = x_mitte - legoSteinListe(index).laengeM/2;
    yol = y_mitte + legoSteinListe(index).breiteM/2;
    
    xor = x_mitte + legoSteinListe(index).laengeM/2;
    yor = y_mitte + legoSteinListe(index).breiteM/2;
    
    xul = x_mitte - legoSteinListe(index).laengeM/2;
    yul = y_mitte - legoSteinListe(index).breiteM/2;
    
    xur = x_mitte + legoSteinListe(index).laengeM/2;
    yur = y_mitte - legoSteinListe(index).breiteM/2;
    
    xmp = x_mitte;
    ymp = y_mitte;
    
    %Transformiere diese Punkte um auch die 
    %-> t fr transformiert
    
    ol_t = transfMatrix * [xol;yol;0;1];
    or_t = transfMatrix * [xor;yor;0;1];
    ul_t = transfMatrix * [xul;yul;0;1];
    ur_t = transfMatrix * [xur;yur;0;1];
    mp_t = transfMatrix * [xmp;ymp;0;1];
    
    
    %Zeichne den transformierten und den untransformierten Stein in dem
    %Plot
    
    zeichneStein(xol,yol,xor,yor,xul,yul,xur,yur,xmp,ymp,steinNr);
    zeichneStein(ol_t(1),ol_t(2),or_t(1),or_t(2),ul_t(1),ul_t(2),ur_t(1),ur_t(2),mp_t(1),mp_t(2),steinNr);
    
    zeichneLinie(xmp,ymp,mp_t(1),mp_t(2));
    
    index = index + 1;
end

return

%Die Kooridinaten wurden nun bestimmt und werden sukzessive angefahren (noch nicht)

index = 1;
while index <= h
    naechsteKooridinaten = legoSteinListe(index).kooridinatenRG; %Lade reale globale Roboterkooridinaten
   
    
    
    index = index + 1;
end


%Test% Funktioniert noch nicht
%test = bestimmeTransformationsmatrixLegoZuRoboterDrehung([1;0;0],[0;1;0])

%Funktionen fr den Programmablauf

function [laengeN, breiteN, laengeM, breiteM] = ermittleAbmessungen(legotyp)
    %Gibt bei Fehler alle Werte mit -1 zurck
    %Diese Funktion sollte eventuell im spteren Projektverlauf durch eine
    %Excel oder XML Datei ersetzt werden um die Daten der Legotypen zu
    %ermitteln -> Benutzerfreundlicher
    
    VIERNOPPENSTEINLAENGE = 0.032;
    ZWEINOPPENSTEINLAENGE = 0.016;
    
    %Wenn kein case betreten wird, dann bleiben alle Werte -1
    laengeN = -1;
    breiteN = -1;
    laengeM = -1;
    breiteM = -1;
    
    
    %Genau genommen funktionale Abhngigkeit zwischen Noppenkooridinaten
    %und realen Kooridinaten -> evtl berarbeiten
    
    %Die Laenge ist die "Gre in x-Richtung" (von oben betrachtet nach rechts ->)
    %Die Breite ist die "Gre in y-Richtung" (von oben betrachtet nach oben ^)
    
    switch legotyp
        case 1
            %1 -> 4x2 normaler Stein -> horizontal
            %Hier die Daten des 4x2 Legosteins ergnzen
            laengeN = 4;
            breiteN = 2;
            laengeM = VIERNOPPENSTEINLAENGE;
            breiteM = ZWEINOPPENSTEINLAENGE;
             
            
        case 2
            laengeN = 2;
            breiteN = 4;
            laengeM = ZWEINOPPENSTEINLAENGE;
            breiteM = VIERNOPPENSTEINLAENGE;
    end
    
end

function drehmatrix = bestimmeTransformationsmatrixLegoZuRoboterDrehung(punktLego, punktRoboter)
    %Soll die Rotation zwischen zwei Punkten rausrechnen, funktioniert aber
    %noch nicht!!!!!!!!!!!!!!

    %bestimmt die Drehmatrix mit welcher die Kooridinaten aus dem
    %Legokooridinatensystem ins Roboterkooridinatensystem transformiert
    %werden knnen. Vorsicht: Offset zur Platte fehlt NUR Drehung!!!!
    
    %punktlego -> wo der Punkt auf der Legoplatte sein msste
    %punktRoboter -> wo der Punkt wirklich ist

    %Es wird angenommen das der Tisch keine Vernderung der z-Kooridinate
    %durch eine Steigung hervorruft -> ideal eben
    %Alle Eingabeparameter sollten 3x1 Vektoren sein, 1->x 2->y 3->z
    
    %Berechne zuerst die Drehung um die z-Achse
    % (ca  -sa 0) (punktLego(1))   
    % (sa  ca  0)*(punktLego(2)) = der gedrehte Punkt, muss aber noch den
    % (0   0   1) (punktLego(3))   Offset auf die erste Legonoppe erhalten
    
    % Substituiere ca -> a; sa ->b
    %LGS per Hand gelst
    
    %Numerisch stabil genug???????????
    
    x = punktLego(1);
    y = punktLego(2);
    z = punktLego(3);
    
    x2 = punktRoboter(1);
    y2 = punktRoboter(2);
    z2 = punktRoboter(3);
    
    if x == 0
        b = x2/y;
        a = (y2+b*x)/(y);
    else
        b = (-1) * ( ((y2 - (x2*y)/(x))) / (x + ((y2 * y2)/ (x)) ));
        a = (x2 - b*y)/(x);
    end
    
    
    drehmatrix = [a,-b,0;
                  b,a,0;
                  0,0,1];
    
              
end

function transfMatrix = bestimmeTransformationsmatrixMitWinkel(drehwinkel, tx, ty, tz)
    %Gibt die kombinierte Drehmatrix mit Rotation und Translation zurck
    %drehwinkel in rad!!!
    %tx in m, Offset zur Noppe unten links auf der Legoplatte in x-Richtung
    %ty in m, Offset zur Noppe unten links auf der Legoplatte in y-Richtung
    %tz in m, Offset zur Noppe unten links auf der Legoplatte in z-Richtung
    
    transfMatrix = [cos(drehwinkel),-sin(drehwinkel), 0,  tx;
                    sin(drehwinkel),cos(drehwinkel), 0,   ty;
                    0,              0,               1,   tz;
                    0,              0,               0,   1];
    
end

%Funktionen zum anfahren von Kooridinaten
%x,  y, z -> Kooridinaten des realen Kooridinatensystems
%rx,ry,rz -> Pose fr den Endeffektor

function greifeLegoSteinVomBand(bx,by,bz,brx,bry,brz)
    %bergebene Parameter: die Kooridinaten welche der Endeffektor haben muss, um den Stein zu greifen
    zOffsetVomBand = 0.03;
    
    fahreZuKooridinaten(bx,by,bz+zOffsetVomBand,brx,bry,brz);
    
end

function platziereLegoStein(x,y,z,rx,ry,rz)
    %Ausgangssituation: der Roboter hat einen Stein gegriffen, und muss
    %diesen auf der Legoplatte platzieren
    
    zOffset = 0.03;   %Fahre zuerst <zOffset> ber die eigentlichen Kooridinaten und setze dann den Stein

    fahreZuKooridinaten(x,y,z + zOffset,rx,ry,rz); %Fahre Kooridinaten von oben an
    fahreZuKooridinaten(x,y,z,rx,ry,rz);
    loeseGreifer();
    fahreZuKooridinaten(x,y,z + zOffset,rx,ry,rz); %Fahre den Offset*2  
end

%In den folgenden Funktionen muss ein String konstruiert werden, der den
%Befehl kodiert

function fahreZuKooridinaten(x,y,z,rx,ry,rz)
    %Erstelle den Befehl und sende diesen ber TCP/IP
    
    %Noch nicht getestet
    
    a = 0.1;
    v = 0.1;
    t = 0;
    r = 0;
    
    movelString = createMovelCommand(x,y,z,rx,ry,rz,a,v,t,r)
    
    %Sende diesen String ber TCP/IP an den UR3
    sendCommandString(movelString)
end

function loeseGreifer()
    %Suche Funktion fr den RG2 Gripper um diesen zu schlieen zu ffnen
end

function greifeNachStein()
    %Suche Funktion fr den RG2 Gripper um diesen zu schlieen zu ffnen
end

%Funktionen fr die Kommunikation ber TCP/IP

function success = initConnection()
    %Die IP Adresse und der Port sind zur Zeit noch fest einkodiert!!!!
    
    %Verbindung herstellen
    Robot_IP = '192.168.0.2';    %Angaben ber die IP-Adresse und den verwendeten Port
    Port_NR = 30003;
    Socket_conn = tcpip(Robot_IP,Port_NR);
    fclose(Socket_conn);
    pause(2);
    try
        %Hier die Herstellung der Verbindung zum Roboter
        fopen(Socket_conn);
        disp('Verbindung erfolgreich hergestellt!')
        hergestellteVerbindung = true;
        success = 1 %Die Verbindung konnte erfolgreich hergestellt werden
    catch Exception
        %Falls die Herstellung der Verbindung fehlgeschlagen ist, so wird
        %dieser Zweig betreten
        
        disp(Exception)
        
        %sound(Audio_connection_error,Fs_connection_error);
        error('Connection to UR10 not possible');
        pause(2);
        disp('Die Verbindung zum Roboter konnte nicht hergestellt werden!')
        success = 0 %Kein Erfolg bei der Verbindungsherstellung
    end
    
end

function sendCommandString(stringToSend)
    fprintf(Socket_conn, befehlMovelStartposition);
end

%Funktionen zum Plotten von Steinen zum Testen der Transformation

function zeichneStein(xol,yol,xor,yor,xul,yul,xur,yur,xmp,ymp,legoNr)
    %Diese Funktion zeichnet einen Legostein, sie dient zum debuggen und
    %verifizieren der Transformation
    
    %Eingabe: 4 Kooridinatenpaare der Ecken des Legosteins, xol -> x oben
    %xmp -> x-Mittelpunkt
    %links
    
    %Linie oben
    zeichneLinie(xol,yol,xor,yor);
    %Linie links
    zeichneLinie(xol,yol,xul,yul);
    %Linie unten
    zeichneLinie(xul,yul,xur,yur);
    %Linie rechts
    zeichneLinie(xor,yor,xur,yur);
    
    %Fge die Nummer des Steines in seinen Mittelpunkt ein
    hold on;
    %text(xmp,ymp,sprintf('%d',legoNr));
    
end

function zeichneLinie(x1,y1,x2,y2)
    %Zeichne die Linie zwischen den angegebenen Punkten
    hold on;
    plot([x1, x2], [y1, y2], 'b-');
end

