%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                         %
% Funktion        : berprfen, ob TCP im Arbeitsraum                     %
%                                                                         %
%                                                                         %
% Eingabe         : TCP-Position und Arbeitsraumgrenzen                   %
%                                                                         %
%                   TCP: Position des TCP in x,y,z                        %
%                                                                         %
%                   range: Min/Max Werte von x,y,z                        %
%                   3x2 Matrix: [xmin xmax ; ymin ymax ; zmin zmax]       %
%                                                                         %
%                                                                         %
% Ausgabe         : workspace: 0 oder 1                                   %
%                   0: TCP befindet sich nicht im Arbeitsraum             %
%                   1: TCP befindet sich im Arbeitsraum                   %
%                                                                         %
%                                                                         %
% Autor           : Kevin Penner                                          %
%                                                                         %
% Implementation  : MATLAB R2016b                                         %
%                                                                         %
% Bemerkung       :                                                       %
%                                                                         %
% nderungsdatum  : 30.05.2017                                            %
%                                                                         %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [workspace] = TCPinWorkspace(TCP, range)
    
    %berprfen, ob TCP im Arbeitsbereich
    if TCP(1) >= range(1,1) && TCP(1) <= range(1,2)...
       && TCP(2) >= range(2,1) && TCP(2) <= range(2,2)...
       && TCP(3) >= range(3,1) && TCP(3) <= range(3,2)
        
        workspace = 1;
   
    else
        
        workspace = 0;
        
    end

end