%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                         %
% Funktion        : Umformen von physikalischen Gren in ein Befehl      %
%                   fr den UR10 --> Fr Bewegungsbefehl movej            %
%                                                                         %
%                                                                         %
% Eingabe         : q: Soll-Winkel in einem 1x6 Vektor                    %
%                   a: Winkelbeschleunigung der Gelenke in rad/s^2        %
%                   v: Winkelgeschwindigkeit der Gelenke in rad/s         %
%                   t: Zeitangabe, wie lange die Bewegung braucht         %
%                   --> hat Prio vor a und v (wird nicht bentigt t=0)    %
%                   r: bergangsradius in m (wir nicht bentigt r=0)      %
%                                                                         %
%                                                                         %
% Ausgabe         : commandString: String des Befehls                     %
%                                                                         %
%                                                                         %
% Autor           : Kevin Penner                                          %
%                                                                         %
% Implementation  : MATLAB R2016b                                         %
%                                                                         %
% Bemerkung       :                                                       %
%                                                                         %
% nderungsdatum  : 03.05.2017                                            %
%                                                                         %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [commandString] = command2string(q,a,v,t,r)    %command2string dient nur dazu, den movej Befehl zu konstruieren
    
    commandString = ['movej([' num2str(q(1)) ', ' num2str(q(2)) ', ' num2str(q(3)) ', ' num2str(q(4))...
                    ', ' num2str(q(5)) ', ' num2str(q(6)) '], ' num2str(a) ', ' num2str(v) ', ' num2str(t)...
                    ', ' num2str(r) ')'];

end